void MarkSet()
{
	object oPC = GetFirstPC();
	object oPort1 = GetObjectByTag("MarkLeave");
	location lTarget = GetLocation(oPC);

	if (GetIsObjectValid(oPort1))
	{
		DestroyObject(oPort1);
	}
	CreateObject(OBJECT_TYPE_PLACEABLE,"markleave",lTarget);
	string message1 = "Marker is set.";
	SetGlobalLocation("Mark", GetLocation(oPort1));
	SendMessageToPC(GetFirstPC(), message1);
}

void RecallSet()
{
	object oPC = GetFirstPC();
	object oPort2 = GetObjectByTag("MarkReturn");
	location lTarget = GetLocation(oPC);

	if (GetIsObjectValid(oPort2))
	{
		DestroyObject(oPort2);
	}
	CreateObject(OBJECT_TYPE_PLACEABLE,"markreturn", lTarget);
	string message2 = "Recall point is set.";
	SetGlobalLocation("Recall", GetLocation(oPort2));
	SendMessageToPC(GetFirstPC(), message2);
}

void PortalMark()
{
	object oPC = GetFirstPC();
	object oMarker = GetObjectByTag("MarkLeave");
	object oRecall = GetObjectByTag("MarkReturn");
	if (GetIsObjectValid(oMarker))
	{
		int Count = 0;
		while(Count <= GetPartyMemberCount())
		{
			object oTeleport = GetPartyMemberByIndex(Count);
			SetCommandable(1, oTeleport);
			AssignCommand(oTeleport, JumpToObject(oMarker));

			DestroyObject(oMarker, 0.2f, 1, 0.0f, 0);
			string message3 = "Marker is destroyed.";
			SendMessageToPC(GetFirstPC(), message3);

			Count++;
		}
	}
}

void PortalRecall()
{
	object oPC = GetFirstPC();
	object oRecall = GetObjectByTag("MarkReturn");
	if (GetIsObjectValid(oRecall))
	{
		int Count = 0;
		while(Count <= GetPartyMemberCount())
		{
			object oTeleport = GetPartyMemberByIndex(Count);
			SetCommandable(1, oTeleport);
			AssignCommand(oTeleport, JumpToObject(oRecall));

			DestroyObject(oRecall, 0.2f, 1, 0.0f, 0);
			string message4 = "Recall point is destroyed.";
			SendMessageToPC(GetFirstPC(), message4);

			Count++;
		}
	}
} 